**********************************************************************
*  DEMO2.PRG    VP-Info demo program...selfrunning with delay factor
*              escape re-starts
*                  Ŀ
*                      Version 3.30  
*                  
*  NOTES to USER:                           Tue  12-24-1991  15:44:38
*       subroutines required:   DEMOLOAD.PRG,DEMO2.PRG,DEMODISP.PRG
*       data files required:    DEMOINV.DBF, DEMOCUST.DBF, DEMOTEMP.DBF,
*                                   DEMOGL.DBF and DEMOTRN.DBF
*       index files required:   DEMOGL1.DBF, DEMOTRN1.DBF
*       library file required:  DEMO.LIB             Ŀ
*       text file required:     DEMO.TXT,NEW.TXT      always compile 
*       report form required:   DEMO.FRM             
*  Always works from menu...self-running selection is timed in seconds
*                           other options ding bell + require key to proceed
* If you want to change text in list of features, edit DEMO.TXT and NEW.TXT
*  \+ means new screen with color change, \\ means same screen + new color
*  fields on \+ line: 4-9 is screen num, 10-19 is offset from column 25
* (C) Copyright 1986-1991 Sub Rosa International Inc.
*  Sid Bursten and Bernie Melman
**********************************************************************
ON error
   SCREEN 1
   WINDOW
   :color=7
   COLOR 7 0 0 24 79
   ? 'Execution terminated on error:',:message
   CANCEL
ENDON
ON escape
   SCREEN 1
   PERFORM fullerase
   SET function on
   COLOR RED 0 0 24 79
   ERASE
   @ 10,10 say 'Demonstration interrupted . . . '
   @ 12,10 say 'Press <ENTER> key to continue . . . spacebar to quit.'
   RING
   signal=inkey()
   IF signal=13
      RETURN
   ELSE
      ok=close()
      WINDOW
      CANCEL
   ENDIF
ENDON
PERFORM fullerase
CURSOR 10,20
:color=ruby
?? 'VP-Info creates informative business graphs'
PERFORM delay2
:color=white
COLOR white 0 0 24 79
@ 1,0 say date(4)
@ 3,0 say cen(:company,80)              ;uses system variable in heading
@ 4,0 say cen("Previous Months' Sales",80)
PERFORM delay3
BOX 7 5 7 75
BOX 10 5 10 75
BOX 13 5 13 75
BOX 16 5 16 75
BOX 19 5 19 75
BOX 4 5 19 5
BOX 20 5 20 75
@ 20,5 say chr(192)
PERFORM delay3
@ 7,0 say '40000'
@ 10,0 say '30000'
@ 13,0 say '20000'
@ 16,0 say '10000'
@ 19,0 say ' 3000'
PERFORM delay3
@ 21,10 say 'January'
@ 21,25 say 'February'
@ 21,40 say 'March'
@ 21,55 say 'April'
@ 23,0 say cen('Total Widget Division',75)
@ 24,80
PERFORM delay2
IF graphics
   COLOR 111 15 10 19 20
   PERFORM delay3
   COLOR  31  8 25 19 35
   PERFORM delay3
   COLOR  79 13 40 19 50
   PERFORM delay3
   COLOR  47 11 55 19 65
ELSE
   BOX 15 10 19 20
   PERFORM delay3
   BOX  8 25 19 35
   PERFORM delay3
   BOX 13 40 19 50
   PERFORM delay3
   BOX 11 55 19 65
ENDIF
RING
PERFORM delay
IF graphics
   PERFORM fullerase
   COLOR 106 2 4 22 75
   :color=106
   WINDOW 5,5,20,75 blank
   TEXT
                      C O L O R


                              C A P A B I L I T I E S


            C O M P A R A B L E


                              T O


                      B A S I C
   ENDTEXT
   PERFORM delay3
   PERFORM delay2
   COLOR 106+128 16 5 20 74
   :color=white
   PERFORM delay
   PERFORM fullerase
   i=0
   REPEAT 10 times vary j
      IF mod(i,8)=3
         i=i+1
      ENDIF
      COLOR i*16 12-j,j*5 12+j,10+j*5
      i=i+1
      DELAY .3
   ENDREPEAT
   PERFORM delay
   REPEAT 1 times
      ERASE
      COLOR 96 0,0 24,79
      j=0
      REPEAT 10 times vary i
         PERFORM delay3
         IF mod(j,8)=3
            j=j+1
         ENDIF
         :color=j+96
         j=j+1
         BOX 1+i,7+i*3 23-i,73-i*3
      ENDREPEAT
      :color=0
      ii=0
      REPEAT 10 times vary j
         PERFORM delay3
         IF mod(ii,8)=3
            ii=ii+1
         ENDIF
         i=mod(j,10)+1
         COLOR 16*ii 1+i,7+i*3 23-i,73-i*3
         ii=ii+1
      ENDREPEAT
   ENDREPEAT
   PERFORM delay
ENDIF graphics
*
*
PROCEDURE fullerase
   WINDOW
   ERASE
   :color=0
ENDPROCEDURE fullerase
*
PROCEDURE delay
   IF pause
      IF menuchoice=1
         DELAY delay2
      ELSE
         @ 23,50 say 'Press spacebar'
         RING
         ok=inkey()
         @ 23,50 say blank(15)
      ENDIF
      delay2=delay
   ENDIF
ENDPROCEDURE delay
*
PROCEDURE delay2
   RING
   IF pause
      DELAY 2
   ENDIF
ENDPROCEDURE delay2
*
PROCEDURE delay3
   RING
   IF pause
      DELAY 1
   ENDIF
ENDPROCEDURE delay3
*
PROCEDURE delay4
   IF pause
      RING
      DELAY 1
   ENDIF
ENDPROCEDURE delay4
*
*                    *** end of program DEMO2.PRG ***
