***************************************************************************
**  ONELABEL.PRG
**  (C) Copyright 1990-92, Sub Rosa Publishing Inc.
**
**  A demonstration program provided to VP-Info users.
**  This program may be copied freely. If it is used in commercial code,
**  please credit the source, Sub Rosa Publishing Inc.
**
**  ONELABEL is a sample program to print mailing labels with very little
**  effort. Key in the text lines and make one or many copies of each label.
**  ONELABEL compatible with all current versions of VP-Info.
**
**  Bernie Melman and Sid Bursten
***************************************************************************
ERASE
CLEAR
SET TALK OFF
mlength=0
DO WHILE mlength<6 OR mlength>18
   INPUT "Label length in lines (6-18): " TO mlength
ENDDO
SET EJECT OFF ; INFO uses line feeds instead of form feed
SET LENGTH TO mlength
line1=blank(28)
line2=blank(28)
line3=blank(28)
line4=blank(28)
line5=blank(28)
ON escape       ;tell VP-Info what to do when <Esc> pressed
   SET eject on
   SET length to 99
   SET print off
   WINDOW
   CURSOR 22,0
   CANCEL
ENDON
DO WHILE t      ;infinite loop - press escape to quit
   SET PRINT Off
   WINDOW 10,10,20,70
   TEXT
   PRESS <END> KEY TO PRINT A LABEL
   PRESS <ESC> KEY TO EXIT

   Line1  @line1
   Line2  @line2
   Line3  @line3
   Line4  @line4
   Line5  @line5
   ENDTEXT
   READ
*   SCREEN 2    ;make printing invisible on screen 1
   SET text off
   SET print on
   TEXT
#line1
#line2
#line3
#line4
#line5
   ENDTEXT
   EJECT
*   SCREEN 1    ;go back to displaying on screen 1
ENDDO
SET PRINT OFF
SET EJECT ON
CHAIN samples
*
*                 *** end of program ONELABEL.PRG ***
