***************************************************************************
**  APPFROM.PRG
**  (C) Copyright 1990-92, Sub Rosa Publishing Inc.
**
**  A demonstration program provided to VP-Info users.
**  This program may be copied freely. If it is used in commercial code,
**  please credit the source, Sub Rosa Publishing Inc.
**
**  APPFROM demonstrates the use of the APPEND FROM command.
**  Records are moved from the file OPENTRAN after the return date is
**  filled in.
**
**  APPFROM is compatible with all current versions of VP-Info.
**
**  Sid Bursten and Bernie Melman
***************************************************************************
WINDOW
ERASE
SET TALK OFF
USE#2 mastran
SELECT 2
APPEND FROM opentran FOR val(return_day)>0
USE#1 opentran
SELECT 1
DELETE ALL FOR val(return_day)>0
PACK ; make deletions permanent
ACCEPT "Do you want to print or display output? (P/D): " TO mprint
IF UPPER(mprint)='P'
   SET PRINT ON
ENDIF
?
? "These are the records now included in mastran.dbf"
?
LIST#2
WAIT
?
?
? "These are the records that remain in opentran.dbf"
?
LIST#1
?
IF UPPER(mprint)="P"
   EJECT
   SET PRINT OFF
ENDIF
WAIT
CHAIN samples
*
*                           *** end of APPFROM.PRG ***
