**********************************************************************
* DEMODISP.PRG    subroutine demonstrates HANDS-ON file features
*                 called by DEMO.PRG (VP-Info Level 1)
*                                         Tue  12-24-1991  15:45:39
* (C) Copyright 1986-1991 Sub Rosa International Inc.
*  Sid Bursten and Bernie Melman
**********************************************************************
SET talk off
ON escape
   SCOPE#4
   SELECT 1
   SCREEN 1
   WINDOW
   SET save on
   USE democust
   RETURN
ENDON
?? chr(7)
SELECT 1
USE &tempfile
ii=4
DO WHILE t
   SCREEN 1,2
   SELECT 1
   ii=ii+1
   :color=b2[mod(ii,10)+1]
   WINDOW 7,46,22,77 double
   TEXT
    Here's a "hands-on"
    demonstration of how
    easy it is to work
    with SR-INFO files.
       SELECT BELOW:

  0. Return to Main Menu

  1. List structure
  2. Edit or Add Records
  3. Edit/Custom Screen
  4. Browse or Add Records
  5. Browse/Custom Screen
  6. Run a report
  7. Account inquiry
   ENDTEXT
   CURSOR 15,47
   ans=menu(7,28)
   WINDOW
   SCREEN 2,1
   ii=ii+1
   :color=b2[mod(ii,10)+1]
   COLOR b2[mod(ii,10)+1] 0 0 24 79
   CURSOR 1,0
   CLEAR gets
   WINDOW
   DO CASE
   CASE ans=0
      SCOPE#4
      SELECT 1
      USE democust
      RETURN
   CASE ans=1
      ERASE
      LIST structure
   CASE ans=2
      EDIT
   CASE ans=3
      WINDOW
      CLS
      DO WHILE t
         EDIT TEXT demoedit
         DO CASE
         CASE :key=335
            BREAK
         CASE eof
            GOTO top
         CASE #<1
            GOTO bottom
            IF eof
               BREAK
            ENDIF
         ENDCASE
      ENDDO
   CASE ans=4
      GO top
      BROWSE
   CASE ans=5
      GO top
      WINDOW
      CLS
      WINDOW 0,16
      BROWSE TEXT demobrow
   CASE ans=6
      SET talk off
      REPORT demo
   CASE ans=7
      PERFORM ddisplay
   ENDCASE
ENDDO
*
PROCEDURE ddisplay
   SET text on
   SCREEN 1
   change=0
   mdate=date(6)
   macct2=blank(6)
   DO WHILE t
      SELECT 3
      SET talk off
      FIND sdavcHGJ
      WINDOW
      ii=ii+1
      :color=b2[mod(ii,10)+1]
      ERASE
      SELECT 3
      macct=macct2
      ans='Y'
      @ 1,0 say date(4)+cen('General Ledger Account Inquiry',50)
      CURSOR 2,10
      TEXT
.. change,999999999.99
.. ans,!
.. macct,999 999
Acct: @macct   (Leave blank to return to menu.)
                                                                         .
Name ............... #name
                                          Ŀ
Opening Balance .... #open                       Correct Account?       
Change ............. #change                  Answer with 1st Letter    
Closing Balance .... #amount                  (Yes/No/Quit/Browse) @ans 
                                          
      ENDTEXT
      ON field
      FIELD 0
         change=open-amount
      FIELD 1
         IF macct=' '
            :field=64
         ELSE
            SET talk off
            FIND &macct
            IF #=0
               IF :near>0
               ELSE
                  GOTO :near
               ENDIF
               GOTO bottom
            ENDIF
            macct=acct
         ENDIF
      FIELD 6
         DO CASE
         CASE @(ans,'BQ')>0
            :field=64
         CASE ans<>'Y'
            :field=1
         ENDCASE
      ENDON
      READ
      DO CASE
      CASE :field=64 .and. ans="B"
         SET save off
         ii=ii+1
         :color=b2[mod(11,10)+1]
         WIND 12,22 blank
         TEXT
                 Account        Account Name

                 @acct          @name
         ENDTEXT
         BROWSE off
         SET save on
         macct2=acct
         LOOP
      CASE :field=64
         BREAK
      ENDCASE
      macct2=blank(6)
      SELECT 4
      SET talk off
      FIND &macct
      IF #<>0
         SCOPE acct
         SET save off
         ii=ii+1
         :color=b2[mod(11,10)+1]
         WIND 12,22 blank
         TEXT
 ACCT   DATE        DESCRIPTION                  INVOICE       AMOUNT

 %acct %mdate %desc %invoice %amount
         ENDTEXT
         ON field
         FIELD 0
            mdate=date(6,date)
         ENDON
         BROWSE off
         SET save on
         WINDOW
         SCOPE
      ENDIF
      SELECT 3
   ENDDO
   WIND
   SCOPE
   SET save on
   SELECT 1
ENDPROCEDURE ddisplay
*
*                        *** end of program DEMODISP.PRG ***
